VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "kCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Base 1
'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 1/8/99 10:28:59 AM
' DESCRIPTION: ' Collection class with additional features
' NOTES:
'------------------------------------------------------
 
Private pFindWhat As Variant
Private pFindIndex As Long
Private pProporMethodByName As String
Private pCallType As Long

Public Col As Collection
Attribute Col.VB_VarMemberFlags = "200"
Attribute Col.VB_VarUserMemId = 0

Private Sub Class_Initialize()
    Set Col = New Collection
End Sub

Private Sub Class_Terminate()
    RemoveAll
    Set Col = Nothing
End Sub

' ************************************************************
' the following routines give the class the same functionality
' as a typical collection class
Public Sub Add(Item, Optional Key, Optional Before, Optional After)
    Col.Add Item, Key, Before, After
End Sub

' remove an item from the collection.
Public Sub Remove(index As Variant)
    If Not VarType(index) = vbString Then index = index + 1
    Col.Remove index
End Sub

' return a count of items in the collection.
Public Function count() As Long
    count = Col.count
End Function

' returns an item located at the specified index.
Public Function Item(ByVal index) As Variant
On Error GoTo errItem
    If Not VarType(index) = vbString Then index = index + 1
    If TypeOf Col.Item(index) Is Object  Then
        Set Item = Col.Item(index)
    Else
        Item = Col.Item(index)
    End If
Exit Function
errItem:
Err.Raise vbObjectError + 1, "kCollection", "Index " + CStr(index) + " does not exist in collection."
End Function

' end base routines ************************************************************
'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 9/8/98 9:52:36 AM
' DESCRIPTION: checks to see if an index exists in a collection
' NOTES:
'------------------------------------------------------
Public Function IndexInCollection(index As String) As Boolean
Dim c As Variant

On Error GoTo ErrHandler
    ' throw error if does not exist
    If TypeOf Col(index) Is Object  Then
    End If
    IndexInCollection = True
    Exit Function
ErrHandler:
    IndexInCollection = False
End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 9/8/98 9:52:36 AM
' DESCRIPTION: checks to see if an item exists in a collection
' NOTES:
'------------------------------------------------------
Public Function ItemInCollection(Optional Item As Variant) As Boolean
    Dim c As Variant
      
    For Each c In Col
        If TypeOf c Is Object  Then
            If c Is Item Then
                ItemInCollection = True
                Exit Function
            End If
        Else
            If c = Item Then
                ItemInCollection = True
                Exit Function
            End If
        End If
    Next c
End Function

'------------------------------------------------------
' DEVELOPER: Larry Chase
' COMPANY: Kiran Consulting Group
' DATE: 6/23/2000 11:28:00 AM
' DESCRIPTION: Revised remove function (doesn't iterate anymore)
' NOTES:
'------------------------------------------------------

Public Sub RemoveAll()
    Set Col = Nothing
    Set Col = New Collection
End Sub


'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 9/8/98 9:26:52 AM
' DESCRIPTION: converts the collection to a string
' NOTES:
'------------------------------------------------------
Public Function CollectionToString(Optional PropOrMethodByName As String = "", Optional CallType As VbCallType = VbGet) As String
    Dim s As String
    Dim c As Variant
    
    If Trim(PropOrMethodByName) = "" Then
    
        For Each c In Col
            s = s + CStr(c) + Chr(13) + Chr(10)
        Next c
    
    Else
    
        For Each c In Col
            s = s + CStr(CallByName(c, PropOrMethodByName, CallType)) + Chr(13) + Chr(10)
        Next c
    
    End If
    
    CollectionToString = s
    
End Function


'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 1/8/99 6:14:30 PM
' DESCRIPTION: copies the collection to the clipboard
' NOTES:
'------------------------------------------------------
Public Function CopyToClipBoard(Optional PropOrMethodByName As String = "", Optional CallType As VbCallType = VbGet) As Boolean
    Dim c As Variant
    Dim s As String
    
    CopyToClipBoard = True
    
    On Error GoTo errClip
    
        Clipboard.Clear
        
        Clipboard.SetText CollectionToString(PropOrMethodByName, CallType)
    
    Exit Function
errClip:
    
    CopyToClipBoard = False
    
End Function


'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 1/8/99 6:14:30 PM
' DESCRIPTION: gets the text off the clipboard and creates a collection based on returns
' NOTES:
'------------------------------------------------------
Public Function GetFromClipBoard() As Boolean
    Dim c As Variant
    Dim s As String
    
    GetFromClipBoard = True
    
    On Error GoTo errClip
    
    s = Clipboard.GetText
    
    CollectionFromString s
    
    Exit Function
errClip:
    
    GetFromClipBoard = False
    
End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 9/4/98 2:58:32 PM
' DESCRIPTION: converts a string into the collection of strings depending on return
'              and line feeds.
' NOTES:
'------------------------------------------------------
Public Function CollectionFromString(s As String) As Boolean
    
    Dim oneStr As String
    Dim pos As Integer
    Dim i As Integer
    
    CollectionFromString = True
    
    On Error GoTo errToString
    
    Me.RemoveAll
    i = 1
    pos = InStr(i, s, Chr(13))
    
        While Not pos = 0
            oneStr = Trim(Mid(s, i, pos - i))
            Col.Add oneStr
            i = pos + 1
            pos = InStr(i + 1, s, Chr(13))
            
            While Mid(s, i, 1) = Chr(10) Or Mid(s, i, 1) = " " Or Mid(s, i, 1) = Chr(13)
                i = i + 1
            Wend
        Wend
        
    oneStr = Trim(Mid(s, i, Len(s)))
    If Not Trim(oneStr) = "" Then Col.Add oneStr
    Exit Function
errToString:
    CollectionFromString = False
    
End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 1/9/99 8:28:21 PM
' DESCRIPTION: replaces a variable in a collection with a new value
' NOTES:
'------------------------------------------------------
Public Property Let Value(index As Variant, NewValue As Variant)

    If IsNumeric(index) Then
    Col.Add NewValue, , , index
    Col.Remove index
    End If

End Property

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 1/9/99 8:29:16 PM
' DESCRIPTION: interface to the Quick sort routine
' NOTES:
'------------------------------------------------------
Public Function SortString() As Boolean
    SortString = QuickSortString(1, Col.count)
End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 1/9/99 8:29:16 PM
' DESCRIPTION: interface to the Quick sort routine
' NOTES:
'------------------------------------------------------
Public Function sortValue() As Boolean
    sortValue = QuickSortValue(1, Col.count)
End Function


Public Function SortObject(PropOrMethodByName As String, CallType As VbCallType) As Boolean
    If Col.count > 0 Then SortObject = QuickSortObject(1, Col.count, PropOrMethodByName, CallType)
End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 1/9/99 8:29:16 PM
' DESCRIPTION: a fast sorting routine for values
' NOTES:
'------------------------------------------------------
Private Function QuickSortValue(iLo As Long, iHi As Long) As Boolean
    Dim Mid As Single
    Dim Lo As Long
    Dim Hi As Long
    Dim T As Single
    
    On Error GoTo errSort
    
    QuickSortValue = True
    
    Lo = iLo
    Hi = iHi
    
    Mid = CSng(Col(Round((Lo + Hi) / 2, 0)))
    
    Do
    
    While CSng(Col(Lo)) < Mid
        Lo = Lo + 1
    Wend
    While CSng(Col(Hi)) > Mid
        Hi = Hi - 1
    Wend
    
    If Lo <= Hi Then
        T = CSng(Col(Lo))
        Me.Value(Lo) = CSng(Col(Hi))
        Me.Value(Hi) = T
        Lo = Lo + 1
        Hi = Hi - 1
    End If
      
    Loop Until Lo > Hi
        If Hi > iLo Then QuickSortValue iLo, Hi
        If Lo < iHi Then QuickSortValue Lo, iHi
    Exit Function
errSort:
    QuickSortValue = False
    
End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 1/9/99 8:29:16 PM
' DESCRIPTION: a fast sorting routine for objects
' NOTES:
'------------------------------------------------------
Private Function QuickSortObject(iLo As Long, iHi As Long, PropOrMethodByName As String, CallType As VbCallType) As Boolean
    Dim Mid As Variant
    Dim Lo As Long
    Dim Hi As Long
    Dim T As Object
    
    'On Error GoTo errSort
    
    QuickSortObject = True
    
    Lo = iLo
    Hi = iHi
    
    Mid = CallByName(Col(Round((Lo + Hi) / 2, 0)), PropOrMethodByName, CallType)
    
    Do
    
    While CallByName(Col(Lo), PropOrMethodByName, CallType) > Mid
        Lo = Lo + 1
    Wend
    While CallByName(Col(Hi), PropOrMethodByName, CallType) < Mid
        Hi = Hi - 1
    Wend
    
    If Lo <= Hi Then
        Set T = Col(Lo)
        Me.Value(Lo) = Col(Hi)
        Me.Value(Hi) = T
        Lo = Lo + 1
        Hi = Hi - 1
    End If
      
    Loop Until Lo > Hi
        If Hi > iLo Then QuickSortObject iLo, Hi, PropOrMethodByName, CallType
        If Lo < iHi Then QuickSortObject Lo, iHi, PropOrMethodByName, CallType
    Exit Function
errSort:
    QuickSortObject = False
    
End Function


'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 1/9/99 8:29:16 PM
' DESCRIPTION: a fast sorting routine for strings
' NOTES:
'------------------------------------------------------
Private Function QuickSortString(iLo As Long, iHi As Long) As Boolean
    
    Dim Mid As String
    Dim Lo As Long
    Dim Hi As Long
    Dim T As String
    
    On Error GoTo errSort
    
    QuickSortString = True
    
    Lo = iLo
    Hi = iHi
    
    Mid = CStr(Col(Round((Lo + Hi) / 2, 0)))
    
    Do
    
    While CStr(Col(Lo)) < Mid
        Lo = Lo + 1
    Wend
    While CStr(Col(Hi)) > Mid
        Hi = Hi - 1
    Wend
    
    If Lo <= Hi Then
        T = Col(Lo)
        Me.Value(Lo) = Col(Hi)
        Me.Value(Hi) = T
        Lo = Lo + 1
        Hi = Hi - 1
    End If
      
    Loop Until Lo > Hi
        If Hi > iLo Then QuickSortString iLo, Hi
        If Lo < iHi Then QuickSortString Lo, iHi
    Exit Function
errSort:
    QuickSortString = False
                   
End Function

 
'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 9/8/98 11:07:37 AM
' DESCRIPTION: ' saves a collection to a file
' NOTES:
'------------------------------------------------------
Public Function WriteToFile(FileName As String) As Boolean
    
    Dim ff As Integer
    Dim c As Variant
    
    On Error GoTo errFile
    
    WriteToFile = True
    
    ff = FreeFile
    Open FileName For Output As ff
        For Each c In Col
            Print #ff, CStr(c)
        Next c
    Close ff
    Exit Function
errFile:
    WriteToFile = False

End Function


'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 9/8/98 11:07:37 AM
' DESCRIPTION: ' retrieves a collection from a file
' NOTES:
'------------------------------------------------------
Public Function ReadFromFile(FileName As String) As Boolean
    Dim ff As Integer
    Dim c As Variant
    
    ReadFromFile = True
    
    Me.RemoveAll
    
    ff = FreeFile
    Open FileName For Input As ff
        While Not EOF(ff)
            Input #ff, c
            Col.Add c
        Wend
    Close ff
    
    Exit Function
errFile:
    
    ReadFromFile = False
    
End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 6/17/99 3:17:30 PM
' DESCRIPTION: ' finds a particular item in the collection
' NOTES:
'------------------------------------------------------
Public Function Find(FindWhat As Variant, Optional PropOrMethodByName As String = "", Optional CallType As VbCallType = VbGet) As Long
    Dim c As Variant
    Dim i As Long
    
    i = 1
    Find = 0
    pFindIndex = 0
    pProporMethodByName = ""
    
    If PropOrMethodByName = "" Then
        If TypeOf FindWhat Is Object  Then
            For Each c In Col
                If c Is FindWhat Then
                    Set pFindWhat = FindWhat
                    pFindIndex = i
                    Find = i
                    Exit Function
                End If
                i = i + 1
            Next c
        Else
            For Each c In Col
                If CStr(c) = CStr(FindWhat) Then
                    pFindWhat = FindWhat
                    pFindIndex = i
                    Find = i
                    Exit Function
                End If
                i = i + 1
            Next c
        End If
    Else
        For Each c In Col
            If CStr(CallByName(c, PropOrMethodByName, CallType)) = CStr(FindWhat) Then
                pFindWhat = FindWhat
                pFindIndex = i
                pProporMethodByName = PropOrMethodByName
                pCallType = CallType
                Find = i
                Exit Function
            End If
            i = i + 1
        Next c
    End If
    
End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 6/17/99 3:17:30 PM
' DESCRIPTION: ' finds the next item based on the last find method
' NOTES:
'------------------------------------------------------
Public Function FindNext() As Long
    
    If pProporMethodByName = "" Then
        If TypeOf pFindWhat Is Object  Then
            For i = pFindIndex + 1 To Col.count
                If Col(i) Is pFindWhat Then
                    pFindIndex = i
                    FindNext = i
                    Exit Function
                End If
            Next i
        Else
            For i = pFindIndex + 1 To Col.count
                If CStr(Col(i)) = CStr(pFindWhat) Then
                    pFindIndex = i
                    FindNext = i
                    Exit Function
                End If
            Next i
        End If
    Else
        For i = pFindIndex + 1 To Col.count
            If CStr(CallByName(Col(i), pProporMethodByName, pCallType)) = CStr(pFindWhat) Then
                pFindIndex = i
                FindNext = i
                Exit Function
            End If
        Next i
    End If
    pFindIndex = 0
    FindNext = 0
    
End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 6/17/99 3:07:42 PM
' DESCRIPTION: returns an array from the collection
' NOTES:
'------------------------------------------------------
Public Function GetArray() As Variant
    Dim a() As Variant
    Dim i As Long
    Dim cnt As Long
    
    cnt = Col.count
    ReDim a(cnt)
    For i = 1 To cnt
        If TypeOf a(i) Is Object  Then
            Set a(i) = Col(i)
        Else
            a(i) = Col(i)
        End If
    Next i
    GetArray = a()

End Function

'------------------------------------------------------
' DEVELOPER: Jeffrey S. Cameron
' COMPANY: Kiran Consulting Group
' DATE: 6/17/99 3:07:42 PM
' DESCRIPTION: Adds only uniquly indexed values
' NOTES:
'------------------------------------------------------
Public Sub AddUnique(Item, Optional Key, Optional Before, Optional After)
    On Error Resume Next
    Col.Add Item, Key, Before, After
    On Error GoTo 0
End Sub
